<!DOCTYPE html>
<html data-VERSION='0.1'>
<!--
***************** ImgurFusker version 0.1 *****************
*********** http://repo.or.cz/w/imgurfusker.git ***********
******** imgurfusker@hmamail.com (expires 7/3/14) *********
**************** Written on July 4th, 2014. ***************
*********** God bless America. God bless nudes. ***********

~~~ ABOUT ~~~

This is a small utility to automatically search for nudes on Imgur via a brute force method.
(This is known as "fusking").

It was inspired by http://noisediary.com/.

I also refer to nudes as "nuuus" throughout this page because I don't fucking feel like putting 'nudes' everywhere.
Deal with it.

~~~ DEPEDENCIES ~~~

The code was originally ripped right from NoiseDiary, but since then it has been heavily
modified and rewritten. Honestly, the person who wrote NoiseDiary can't fucking code anyway.

This page uses jQuery. If you don't know what jQuery is then fuck off.

The image detection is done by a library known as nude.js.
https://github.com/pa7/nude.js

~~~ QUESTIONS ~~~

Q: Why did you do this?
A: Hello? Fucking nudes.

Q: Why does it keep finding non-nudes and skip B&W nudes?
A: Because fuck you, that's why. I didn't write the library.
   You think you can do better? Go write a better library and come back to me. I'll use your library.

Q: Why is it freezing up my computer? You fucking suck at this.
A: No YOU suck. Scanning the image is resource intensive and can freeze your browser if the FAIL_TIME option is set too low.

~~~ Contributing ~~~

Because of the nature of the project, it is developed and hosted entirely anonymously.

  1. Fucking get permission from me first.

    And learn how to use Git if you don't already.

  2. Generate an SSH key.

    If you don't know how, google it. I'm going to hold your fucking hand, especially if you're a Windows user.

  3. Register an "account" at http://repo.or.cz/reguser.cgi

    Your email doesn't even have to be legit, though I would recommend at least using a temporary one from
    https://securemail.hidemyass.com/ in case you need to change your SSH key.

  4. Clone the project

    Command is: git clone git://repo.or.cz/imgurfusker.git

  5. Inside the project directory, edit the config file at .git/config

    Add this to the end, substituting your own info where noted:

      [user]
        name = 'Anonymous' 
        email = '<YOUR_HMA_EMAIL_OR_LEAVE_BLANK>'
      [remove "origin"]
        url = ssh://<YOUR_ORCZ_USERNAME>@repo.or.cz/srv/git/imgurfusker.git
        fetch = +refs/heads/*:refs/remotes/origin/*



~~~ LICENSING BULLSHIT ~~~

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://www.wtfpl.net/ for more details.

-->
  <head>
    <meta http-equiv="content-type" content="text/html; charset=UTF-8">
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="">
    <meta name="author" content="">

    <title>ImgurFusker</title>
    <link rel="stylesheet" type="text/css" href="http://fonts.googleapis.com/css?family=Open+Sans:400,300,300italic,400italic,600,600italic,700,700italic">
    <style>
      body {
        font-family: "Open Sans","Helvetica Neue",Helvetica,Arial,sans-serif;
      }
      @media (min-width: 1200px) { /* Large desktop */
          body { padding: 0 50px; }
      }

      @media (min-width: 768px) and (max-width: 1199px) { /* Portrait tablet to landscape and desktop */
          body { padding: 0 30px; }
      }

      @media (max-width: 767px) { /* Landscape phone to portrait tablet */
          body { padding: 0 20px; }
      }

      @media (max-width: 480px) { /* Landscape phones and down */
          body { padding: 0 5px; }
      }

      h1 {
        font-size: 2.7em;
        margin: .2em .4em;
        font-family: 'Open Sans','Courier';
        font-weight: 100;
      }
      h1 small {
        font-size: .3em;
      }
      h2 {
        font-size: 2.3;
        font-family: 'Open Sans','Courier';
        font-weight: 400;
        margin: 0;
      }

      a:hover, a:visited, a:link, a:active {
          text-decoration: none;
      }

      img {
        vertical-align: text-bottom;
      }

      .btn {
          display: inline-block;
          margin-bottom: 0px;
          font-weight: normal;
          text-align: center;
          vertical-align: middle;
          cursor: pointer;
          background-image: none;
          
          white-space: nowrap;
          padding: 0.5em 1em;
          font-size: 1em;
          line-height: 1;

          color: #333;
          background-color: #E7E7E7;
          border: 1px solid #DADADA;
      }
      .btn:hover {
          background-color: #DADADA;
      }
      .btn-block {
          display: block;
          width: 100%;
          padding: 1em 2em;
      }

      #images {
        margin: 20px 0;
      }

      .thumb-container {
        display:inline-block; 
        position:relative;
        overflow:show;
        min-height:110px;
        min-width:110px;
        clear:both;
      }
      .thumb {
        height: 110px;
        width: 110px;
      }

      #images img {
        margin-right: 5px;
        border: 2px solid transparent;
      }
      #images img:hover, .delort:hover{
        border-color: #ff0000;
      }

      .sauce, .delort {
        z-index:1000; 
        height:16px;
        width:16px;
        position:absolute;
        padding:0px;
      }
      .sauce {
        bottom:10px;
        margin-right: 0;
        right:12px;
      }
      .delort {
        right:7px;
        border: 2px solid transparent;
        font-weight: bold;
        font-size: 20px;
        text-align:center;
        cursor: pointer;
        line-height:.6;
        background-color: #333;
      }
      .delort, .delort:focus, .delort:hover {
        color: red;
      }
      .delort:hover {
        border-color: #ff0000;
      }

      #examining {
        font-weight: 100;
        font-size: 20px;
      }
      #examining i {
        font-style: italic;
        color: #888;
      }

      #current {
        text-align:center;
        height: 340px;
        background-color: #FFFFE0;
      }
      #current img {
        max-height: 300px;
        max-width: 400px;
      }

      #cache-popup {
        position: absolute;
        display: block;
        min-height: 100px; //adjust as per need
        min-width: 350px; //adjust as per need
        z-index: 200;
        background: white;
        top: 150px;
        border: 2px solid #999;
        border-radius: 10px 10px;
        padding: 15px;
        width: 600px;
        left: 0;
        right: 0;
        margin: auto;
      }

    </style>




  </head>

  <body>
    <h1>ImgurFusker</h1>
	
    <button id="bigass-button" class="btn btn-block">Start!</button>

    <div id="current">
      <h4 id="examining"></h4>
      <img id="current-img">
    </div>

    <div id="images"></div>

    <div onclick='document.getElementById("cache-popup").style.visibility="visible";' class="btn" style="float: right">
    Past
    </div>
    <div id="cache-popup" style="visibility: hidden;" >
      <button onclick='document.getElementById("cache-popup").style.visibility="hidden";' class="btn" style="float:right; padding:0 2px; font-weight:100">x</button>
      <h2>Past Images</h2>
      <div id="cache-images">
      </div>
    </div>

    <div class='thumb-container' id='img-template' style="display:none">
      <a href='' target='_blank' class='thumb'>
        <img src='' class=''>
      </a>
      <span class='delort'>x</span>
      <a href='' class='sauce' target='_blank' rel='noreferrer' alt='original imgur page'>
        <img src='http://imgur.com/favicon.ico'>
      </a>
    </div>
    <canvas id="myCvs" style="display:none"></canvas> 
    <!-- Popup itself -->

    <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
    <script src="nude.js" type="text/javascript"></script>
    <script src="worker.nude.js" type="text/javascript"></script>
    <!--<script src="noworker.nude.js" type="text/javascript"></script>-->


    <script type="text/javascript">

    
      var VERSION = $(document.getElementsByTagName("html")[0]).data('version')

      var opt = {
        DEBUG:            false,    // Will flag EVERY image as a nuuu.
        FAIL_TIME:        500,      // How long to wait, in ms, between tries (NOTE: Setting this too low may cause your browser to freeze)
        SUCCESS_TIME:     10000,    // How long to wait, in ms, after finding a nuuu to continue searching (This is just for you to look at the nuuu.)
        STOP_WHEN_FIND:   false,    // Whether or not to automatically stop after 
        SCAN_THUMBNAILS:  false,    // Scan the thumbnail instead of the full image. Will be a lot faster, but will lead to MANY more false positives.
        SHOW_CURRENT:     true,     // Whether or not to show the image currently being scanned.
      }

      var imgurcache = new Array();

      var thumb_link = function(id) { return 'http://i.imgur.com/'+id+'s.png'}
      var img_link = function(id) { return 'http://i.imgur.com/'+id+'.jpg'}


      $('h1').append(" v" + VERSION);
      document.title = document.title + " v" + VERSION;
      if(opt.DEBUG)
        $('h1').append("<small style='color:red; font-size:.3em;'>Debug mode</small>");
      if(!opt.SHOW_CURRENT) {
          $('#current').css('height', 'auto');
          $('#current img').css('display', 'none');
      }



      var Imgur = {
        stop: false,
        status: function(txt, clr) {
          $('#examining').text(txt);
          $('#examining').css('color', clr);
          console.log(txt);
        },
        
        hunt: function() {
          var self=this;
          console.log(self.stop());
          if(self.stop())
            return;

          var id = self.random(5),
          img = new Image;
          img.crossOrigin = "Anonymous";

          function fail(fail_id, fail_reason) {

            self.status("Checked " + fail_id + ". " + fail_reason, '#333')
            if(self.stop())
              return;
            setTimeout(function(){self.hunt()}, opt.FAIL_TIME);
          }
          img.onerror = fail;
          img.onload = function() {
            // PHASE 1: Look for an actual image
            if ((img.width==198 && img.height==160) || (img.width==161 && img.height==81)) {
              // assume this is an imgur error image, and retry.
              fail(id, "Hunting for next image...");
            } else {

              //We've found AN image; now to do the actual checking
              $('#cache-images').append('<a target="_blank" href="'+img_link(id)+'"><img src="'+thumb_link(id)+'"></a>');

              var cvs = document.getElementById('myCvs'),
              ctx = cvs.getContext('2d');
              cvs.height = img.height;
              cvs.width = img.width;
              ctx.drawImage( img, 0, 0);
              var datum = cvs.toDataURL();


              //
              var img2 = document.getElementById('current-img');
              img2.onerror = function(wat) {
                self.status("A horrible error occurred during Phase 2.", 'red')
                if(self.stop())
                  return;
                console.log(wat);
              }
              img2.onload = function() {
                self.status("Checking " + id + " for nuuity", '#000');
                if(self.stop())
                  return;
                nude.load(img);
                if(self.stop())
                  return;
                nude.scan(function(is_nude){
                  if(is_nude || opt.DEBUG)
                    self.found(id);
                  else
                    fail(id, "Not a nude.");
                });
              }
              self.status("Checking " + id, '#000')
              if(self.stop())
                return;
              img2.src = datum;
            }
          }; // </onload>
          if(opt.SCAN_THUMBNAILS)
            img.src = thumb_link(id);
          else
            img.src = img_link(id);
        }, // </hunt>
        found: function(id) {
            var self=this;
            
            var new_node = $('#img-template').clone();
            new_node.css('display', 'inline');
            new_node.attr('id', "thumb" + id);
            new_node.find('.thumb').attr("href", img_link(id));
            new_node.find('.thumb img').attr("src", thumb_link(id));
            new_node.find('.thumb img').addClass("thumb" + id);
            new_node.find('.sauce').attr('href', "http://imgur.com/" + id);
            new_node.find('.delort').click(function() { $(this).parent().remove() });
            $('#images').append(new_node);
                            
            self.status("Aw yiss, found a nuuu at " + id, '#3c0');
            if(self.stop(true))
              return;
            if(!(opt.SUCCESS_TIME>0)) {
              self.hunt();
              return;
            }
            // Wait a few seconds so we can view the nuuu
            var until = opt.SUCCESS_TIME;
            $('#examining').append(' <b>' + (until/100) + '</b>');
            var until_f = function() {
              if(self.stop()) {
                $('#examining b').remove();
                return;
              }

              until-=100;
              if(until<0)
                self.hunt();
              else {
                $('#examining b').text((until/100));
                console.log("Starting again in " + until);
                setTimeout(until_f, 100);
              }
            }
            setTimeout(until_f, 100);
          },
        random: function(len) {
          var text = new Array();
          var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
          for (var i=0; i < len; i++) {
            imgurchar = possible.charAt(Math.floor(Math.random() * possible.length));
            possible.replace(imgurchar, '');
            text.push(imgurchar);
          }
          text = text.join('');
          if (imgurcache.indexOf(text) == -1) {
            imgurcache.push(text);
            return text;
          } else {
            self.random(5);
            return false;
          }
        },
        start: function(e) {
          console.log("The hunt is on");
          self.stop_plz = false; //gooby, pls
          Imgur.hunt();
          $('#bigass-button').unbind('click', self.start);
          $('#bigass-button').bind('click', function() {
            console.log("Stopping");
            self.stop_plz = true;
          });
          $('#examining i').remove();
          $("#bigass-button").text("Stop");
        },
        stop: function(nuuu_obtained) {
          if(self.stop_plz || (nuuu_obtained!=undefined && opt.STOP_WHEN_FIND)) {
            if($('#examining i').remove())
              $('#examining').prepend("<i>[Stopped]</i> ");
            $("#bigass-button").text("Resume");
            $("#bigass-button").unbind('click', self.stop);
            $("#bigass-button").bind('click', Imgur.start);
            return true;
          }
          return false;
        }
      };
      $('#bigass-button').click(Imgur.start);
    </script>

  </body>
</html>